﻿using System;
using System.Collections.Generic;
using System.Text;
using System.ComponentModel;
using System.Windows.Forms;
using Infragistics.Win.UltraWinGrid;
namespace GridPasteSample
{
    public class BaseEntityMngt2 : IDisposable
    {
        private BindingSource _entityBindingSource;
        public BindingSource EntityBindingSource
        {
            get
            {
                if (_entityBindingSource == null)
                    _entityBindingSource = new BindingSource();
                return _entityBindingSource;
            }
            set { _entityBindingSource = value; }
        }
        #region Disposable stuff
        // Pointer to an external unmanaged resource.
        private IntPtr handle;
        // Other managed resource this class uses.
        private System.ComponentModel.Component Components = new System.ComponentModel.Component();
        // Track whether Dispose has been called.
        private bool disposed = false;
        public BaseEntityMngt2()
        {

        }
        // Implement IDisposable.
        // Do not make this method virtual.
        // A derived class should not be able to override this method.
        public void Dispose()
        {
            Dispose(true);
            // Take yourself off the Finalization queue 
            // to prevent finalization code for this object
            // from executing a second time.
            GC.SuppressFinalize(this);
        }

        // Dispose(bool disposing) executes in two distinct scenarios.
        // If disposing equals true, the method has been called directly
        // or indirectly by a user's code. Managed and unmanaged resources
        // can be disposed.
        // If disposing equals false, the method has been called by the 
        // runtime from inside the finalizer and you should not reference 
        // other objects. Only unmanaged resources can be disposed.
        protected virtual void Dispose(bool disposing)
        {
            // Check to see if Dispose has already been called.
            if (!this.disposed)
            {
                // If disposing equals true, dispose all managed 
                // and unmanaged resources.
                if (disposing)
                {
                    // Dispose managed resources.
                    if (Components != null)
                        Components.Dispose();
                    if (_entityBindingSource != null)
                        _entityBindingSource.Dispose();
                    _entityBindingSource = null;

                    //if (_ultraCombo != null && !_ultraCombo.IsDisposed)
                    //    _ultraCombo.Dispose();
                    //_ultraCombo = null;

                }
                // Release unmanaged resources. If disposing is false, 
                // only the following code is executed.
                //CloseHandle(handle);
                handle = IntPtr.Zero;

                // Note that this is not thread safe.
                // Another thread could start disposing the object
                // after the managed resources are disposed,
                // but before the disposed flag is set to true.
                // If thread safety is necessary, it must be
                // implemented by the client.

            }
            disposed = true;
        }

        // Use C# destructor syntax for finalization code.
        // This destructor will run only if the Dispose method 
        // does not get called.
        // It gives your base class the opportunity to finalize.
        // Do not provide destructors in types derived from this class.
        ~BaseEntityMngt2()
        {
            // Do not re-create Dispose clean-up code here.
            // Calling Dispose(false) is optimal in terms of
            // readability and maintainability.
            Dispose(false);
        }

        #endregion Disposable Stuff
    }
}
